"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const read_1 = require("./read");
exports.createEntryReader = read_1.createEntryReader;
const render_1 = require("./render");
exports.createEntryRenderer = render_1.createEntryRenderer;
const __1 = require("..");
exports.defaults = __1.defaults;
var render_2 = require("./render");
exports.createTemplateProcessor = render_2.createTemplateProcessor;
exports.renderEntry = render_2.renderEntry;
var read_2 = require("./read");
exports.createFileProcessor = read_2.createFileProcessor;
exports.readEntry = read_2.readEntry;
function createEntryRenderHandler(config) {
    let { info } = config;
    info = info || __1.defaults.info;
    info('createEntryRenderHandler');
    const entryReader = read_1.createEntryReader(config);
    const entryRenderer = render_1.createEntryRenderer(config);
    return function (entry) {
        info('decide: renderer vs reader ', {
            isTemplate: entry.isTemplate
        });
        return entry.isTemplate ? entryReader(entry, config) : entryRenderer(entry, config);
    };
}
exports.createEntryRenderHandler = createEntryRenderHandler;
//# sourceMappingURL=index.js.map