"use strict";
// can collect entries from templates folder in any way
// entries are any objects to be iterated to cause side effects in destination project
// however the API consumer should be in full control of what side effects (ie. actions) are available
// render and copy are types of actions
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const defaults = {
    result: { valid: true }
};
function validate(config = {}) {
    let { info, } = config;
    return function (entries) {
        return __awaiter(this, void 0, void 0, function* () {
            info && info('validate', entries);
            const promises = entries.map((entry) => __awaiter(this, void 0, void 0, function* () {
                info && info('validate', {
                    entry
                });
                let result;
                try {
                    result = (yield entry.validate) ? entry.validate() : defaults.result;
                }
                catch (err) {
                    return { valid: false, err };
                }
                return result;
            }));
            return Promise.all(promises);
        });
    };
}
exports.validate = validate;
//# sourceMappingURL=validate.js.map