"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const entry_types_1 = require("./entry-types");
const param_defs_1 = require("./param-defs");
const validate_params_1 = require("./validate-params");
function entryParams(entry, options = {}) {
    const { info, templatesPath } = options;
    info && info('populateEntry', {
        templatesPath,
        entry,
        options
    });
    const paramDefsPath = path.join(templatesPath, 'template.params.js');
    const paramDefs = param_defs_1.resolveParamDefsAt(paramDefsPath, options);
    const filePath = path.join(templatesPath, 'template.data.js');
    const { params, uses } = entry_types_1.resolveEntryDataAt(filePath, entry, options);
    info && info('entryParams', {
        entry,
        params,
        uses,
        paramDefs,
        options
    });
    return validate_params_1.validateParams({
        params,
        uses,
        paramDefs
    }, options);
}
exports.entryParams = entryParams;
//# sourceMappingURL=entry-params.js.map